package cc.fascinated.bat.base;

import cc.fascinated.bat.common.feature.Feature;
import cc.fascinated.bat.common.feature.FeatureProfile;
import cc.fascinated.bat.base.commands.botadmin.BotAdminCommand;
import cc.fascinated.bat.base.commands.fun.CoinFlipCommand;
import cc.fascinated.bat.base.commands.fun.EightBallCommand;
import cc.fascinated.bat.base.commands.fun.PPSizeCommand;
import cc.fascinated.bat.base.commands.fun.image.ImageCommand;
import cc.fascinated.bat.base.commands.general.*;
import cc.fascinated.bat.base.commands.general.avatar.AvatarCommand;
import cc.fascinated.bat.base.commands.general.banner.BannerCommand;
import cc.fascinated.bat.base.commands.server.MemberCountCommand;
import cc.fascinated.bat.base.commands.server.PremiumCommand;
import cc.fascinated.bat.base.commands.server.channel.ChannelCommand;
import cc.fascinated.bat.base.commands.server.feature.FeatureCommand;
import cc.fascinated.bat.base.commands.utility.PastebinCommand;
import cc.fascinated.bat.base.commands.utility.lookup.LookupCommand;
import cc.fascinated.bat.service.OldCommandService;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class BaseFeature extends Feature {
    @Autowired
    public BaseFeature(@NonNull ApplicationContext context, @NonNull OldCommandService commandService) {
        super("Base", FeatureProfile.FeatureState.ENABLED, false);

        super.registerCommand(commandService, context.getBean(PremiumCommand.class));
        super.registerCommand(commandService, context.getBean(BotAdminCommand.class));
        super.registerCommand(commandService, context.getBean(MemberCountCommand.class));
        super.registerCommand(commandService, context.getBean(ChannelCommand.class));
        super.registerCommand(commandService, context.getBean(VoteCommand.class));
        super.registerCommand(commandService, context.getBean(PingCommand.class));
        super.registerCommand(commandService, context.getBean(InviteCommand.class));
        super.registerCommand(commandService, context.getBean(BotStatsCommand.class));
        super.registerCommand(commandService, context.getBean(BannerCommand.class));
        super.registerCommand(commandService, context.getBean(AvatarCommand.class));
        super.registerCommand(commandService, context.getBean(ImageCommand.class));
        super.registerCommand(commandService, context.getBean(FeatureCommand.class));
        super.registerCommand(commandService, context.getBean(EightBallCommand.class));
        super.registerCommand(commandService, context.getBean(LookupCommand.class));
        super.registerCommand(commandService, context.getBean(PPSizeCommand.class));
        super.registerCommand(commandService, context.getBean(PastebinCommand.class));
        super.registerCommand(commandService, context.getBean(CoinFlipCommand.class));
    }
}
