package cc.fascinated.bat.base.commands.general;

import cc.fascinated.bat.common.oldcommand.BatCommand;
import cc.fascinated.bat.common.oldcommand.Category;
import cc.fascinated.bat.common.oldcommand.CommandInfo;
import cc.fascinated.bat.common.model.BatGuild;
import cc.fascinated.bat.common.model.BatUser;
import cc.fascinated.bat.service.DiscordService;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(
        name = "ping",
        description = "Gets the ping of the bot",
        guildOnly = false,
        userInstall = true, 
        category = Category.GENERAL
)
public class PingCommand extends BatCommand {
    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, Message commandMessage, String[] arguments, SlashCommandInteraction event) {
        long time = System.currentTimeMillis();
        event.reply("Pinging...").queue(response -> {
            response.editOriginal("Gateway response time: `%sms`\nAPI response time `%sms`".formatted(
                    DiscordService.JDA.getGatewayPing(),
                    System.currentTimeMillis() - time
            )).queue();
        });
    }
}
