package cc.fascinated.bat.common;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NonNull;
import lombok.RequiredArgsConstructor;

/**
 * Emojis used by Rufus.
 *
 * @author Braydon
 */
@AllArgsConstructor @RequiredArgsConstructor @Getter
public enum BatEmoji {
    RUFUS("rufus", "1319317309608689674"),
    LOADING("loading", "1319483685787013212", true),
    SUCCESS("success", "1319483459781132410"),
    CROSS("cross", "1319483437928677446");

    /**
     * The name of this emoji.
     */
    @NonNull private final String name;

    /**
     * The ID of this emoji.
     */
    @NonNull private final String id;

    /**
     * Whether this emoji is animated.
     */
    private boolean animated;

    /**
     * Get the formatted emoji.
     *
     * @return the formatted emoji
     */
    @Override @NonNull
    public String toString() {
        return (animated ? "<a:" : "<:") + name + ":" + id + ">";
    }
}