package cc.fascinated.bat.namehistory;

import cc.fascinated.bat.common.feature.Feature;
import cc.fascinated.bat.common.feature.FeatureProfile;
import cc.fascinated.bat.namehistory.command.NameHistoryCommand;
import cc.fascinated.bat.service.OldCommandService;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class NameHistoryFeature extends Feature {
    public static final int NAME_HISTORY_SIZE = 25;

    @Autowired
    public NameHistoryFeature(@NonNull ApplicationContext context, @NonNull OldCommandService commandService) {
        super("Name History", FeatureProfile.FeatureState.DISABLED, true);

        super.registerCommand(commandService, context.getBean(NameHistoryCommand.class));
    }
}
