package cc.fascinated.bat.namehistory.command;

import cc.fascinated.bat.common.oldcommand.BatCommand;
import cc.fascinated.bat.common.oldcommand.Category;
import cc.fascinated.bat.common.oldcommand.CommandInfo;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "namehistory", description = "View the name history of a user", category = Category.GENERAL)
public class NameHistoryCommand extends BatCommand {
    @Autowired
    public NameHistoryCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(UserSubCommand.class),
                context.getBean(GuildSubCommand.class)
        );
    }
}
