package cc.fascinated.bat.statschannel.command;

import cc.fascinated.bat.common.oldcommand.BatCommand;
import cc.fascinated.bat.common.oldcommand.CommandInfo;
import lombok.NonNull;
import net.dv8tion.jda.api.Permission;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(
        name = "stats-channel",
        description = "Change your stats channel settings",
        requiredPermissions = Permission.MANAGE_SERVER
)
public class StatsChannelCommand extends BatCommand {
    @Autowired
    public StatsChannelCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(AddSubCommand.class),
                context.getBean(RemoveSubCommand.class),
                context.getBean(CurrentSubCommand.class)
        );
    }
}
