package cc.fascinated.bat.welcomer.command;

import cc.fascinated.bat.common.oldcommand.BatCommand;
import cc.fascinated.bat.common.oldcommand.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.welcomer.WelcomerProfile;
import cc.fascinated.bat.common.model.BatGuild;
import cc.fascinated.bat.common.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component("welcomer:reset.sub")
@CommandInfo(name = "reset", description = "Clear the welcomer configuration")
public class ResetSubCommand extends BatCommand {
    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, Message commandMessage, String[] arguments, SlashCommandInteraction event) {
        WelcomerProfile profile = guild.getWelcomerProfile();
        if (!profile.isEmbed() && !profile.isMessage()) {
            event.replyEmbeds(EmbedUtils.errorEmbed()
                    .setDescription("The welcomer is not configured")
                    .build()).queue();
            return;
        }

        profile.reset();
        event.replyEmbeds(EmbedUtils.successEmbed()
                .setDescription("The welcomer configuration has been reset")
                .build()).queue();
    }
}
